' ============================================================================
' GarfieldStrip.vbs		v1.2
' ============================================================================
'
'GarfieldStrip script by Stefan Thrane Overby
'
'
'
'Part of code from DK Text-TV scripts by Bjarne Duelund
'
'Most code from side9pige.vbs by SEAHAWK
'Thank you for that great script
'
'
'*******  Please read this before using the script  *******
'
'
'The script fetches the Garfield strip of the day from http://www.ucomics.com/garfield/ 
'and saves it as .png file ready to show
'Just run the function "GarfieldStrip" and select the output 
'to be a PNG-file and width = 600 height = 180
'
'The files are saved in a folder called "Garfield\" under your Samurize directory.
'
'
'No need of Parameters to locate IrfanView. 
'
'
'
'
'
'
'
'NOTE : Be sure to have IrFanView installed
'
'
'
'
'
'
'############# DONT EDIT BELOW THIS LINE ###############
'
'
'

	Dim day, month, year, PathToIrfanView
	

Function GarfieldStrip

	day = datepart("d",date(),2,2)
	month = datepart("m",date(),2,2)
	year = datepart("yyyy",date(),2,2)

	If len(day) = 1 then
		day = "0" & day
	End If
	If len(month) = 1 then
		month = "0" & month
	End If
	If len(year) = 4 then
		yearShort = right(year,2)
	End If


	ProgramFiles = CreateObject("WScript.Shell").ExpandEnvironmentStrings("%ProgramFiles%")
	PathToIrfanView = ProgramFiles & "\irfanview"
	imgToday = day & "-" & month & "-" & yearShort & ".png"
	SamDir = CreateObject("WScript.Shell").RegRead("HKEY_CURRENT_USER\Software\Serious Samurize\General\DirPath")
	GarDir = SamDir & "Garfield\"
' If "Garfield\" dont exists it will be created.
	Set fso = CreateObject("Scripting.FileSystemObject")
	If (fso.FolderExists(GarDir)) Then
    Else
 	fso.CreateFolder(GarDir)
    End If

	imgToday = GarDir & imgToday

' Does to day exists?
	ImageToDay = doesFileExists(imgToday)
	If ImageToDay = "YES" Then
' To day exists and the image will NOT be updated.
		imgName = imgToday	
	Else
' The image does NOT exists and will be retrived.
		html = GetHTML("http://www.ucomics.com/garfield/")

		imgURL = trim(GetData(html, "http://images.ucomics.com/comics/ga/" & Year & "/ga" & YearShort & Month & Day))
' To day image can be retrived. 
		If imgURL <> "" Then
' Get image and convert.
			imgName = GetPicture(imgURL, imgToday, pathToIrfanView)
		Else
' To day image is NOT avalible, does yesterday exists?
			imgYesterday = GarDir & getDay(1) & "-" & getMonth(1) & "-" & getYearShort(1) & ".png"
			ImageYesterday = doesFileExists(imgYesterday)
			If ImageYesterday = "YES" Then
' Yesterday image EXISTS and the image will NOT be updated.
				imgName = imgYesterday	
			Else
' Yesterday image does NOT exists and  will be retrived.			
				imgURL = trim(GetData(html, "http://images.ucomics.com/comics/ga/" & Year & "/ga" & YearShort(1) & Month(1) & Day(1)))
' Yesterday image can be retrived.
				If imgURL <> "" Then
' Get image and convert.
					imgName = GetPicture(imgURL, imgYesterday, pathToIrfanView)
				Else
' Yesterday image is NOT avalible, does the day before yesterday exists?
					img2Days = GarDir & getDay(2) & "-" & getMonth(2) & "-" & getYearShort(2) & ".png"
					ImageDayBefore = doesFileExists(img2Days)
					If ImageDayBefore = "YES" Then
' The day before yesterday image EXISTS and the image will NOT be updated.		
						imgName = img2Days 
					Else
' The day before yesterday image does NOT exists and  will be retrived.	
						imgURL = trim(GetData(html, "http://images.ucomics.com/comics/ga/" & Year & "/ga" & YearShort(2) & Month(2) & Day(2)))
' The day before yesterday image can be retrived.

						If imgURL <> "" Then
' Get image and convert.
							imgName = GetPicture(imgURL, img2Days, pathToIrfanView)
						Else
' The day before yesterday image is NOT avalible, we give up.
							imgName = GarDir & "NoSource.png"
						End If 
					End If 'Does the day before yesterday exists?
				End If 'Yesterday can be retrived.
			End If 'Does yesterday exists?
		End If 'To day image can be retrived.
	End If 'Does image to day exists?

	GarfieldStrip = imgName
End function




Private Function doesFileExists(filename)
	Dim result
	Set fso = CreateObject("Scripting.FileSystemObject")
	If (fso.FileExists (filename)) then
		result = "YES"
	Else
		result = "NO"
	End If
	doesFileExists = result
End function




Private Function getDay(daysbefore)
	Select Case day
		Case "01"
			Select Case month
				Case "01","02","04","06","08","09","11"
					newday = 31-daysbefore+1
				Case "03"
					newday = 29-daysbefore+1
				Case "05","07","10","12"
					newday = 30-daysbefore+1
				Case Else
			End Select
		Case "02"
			If (daysbefore >= 2) Then
				Select Case month
					Case "01","02","04","06","08","09","11"
						newday = 31-daysbefore+2
					Case "03"
						newday = 29-daysbefore+2
					Case "05","07","10","12"
						newday = 30-daysbefore+2
					Case Else
				End Select
			Else
				newday = day-daysbefore
			End If
	Case Else
		newday = day-daysbefore
	End Select
	If len(newday) = 1 Then
		newday = "0" & newday
	End If
	getDay = newday
End Function




Private Function getMonth(daysbefore)
	If day = 01 AND daysbefore > 0 Then
		If month = 01 Then
			newmonth = 12
		Else
			newmonth = month-1 
			If len(newmonth) = 1 Then
				newmonth = "0" & newmonth
			End If
		End If
	Else
		If day = 02 AND daysbefore > 1 Then
			If month = 01 Then
				newmonth = 12
			Else
				newmonth = month-1
			End If
		Else
			newmonth = month
		End If
	End If
	If len(newmonth) = 1 Then
		newmonth = "0" & newmonth
	End If	
	getMonth = newmonth
End Function




Private Function getYearShort(daysbefore)
	If ((day = "01") AND (month = "01")) Then
		newyear = yearShort-1
	Else
		If ((day = 2) AND (daysbefore = 2) AND (month = 1)) Then
			newyear = yearShort-1
		Else
			newyear = yearShort
		End If
	End If
	If len(newyear) = 1 Then
		newyear = "0" & newyear
	End If
	getYearShort = newyear
End Function




Private function GetData(html, text)
	dim pos1,pos2
	If InStr(html, text) = 0 Then
		GetData = ""
	Else
		pos1 = instr(html,text)
		pos2 = instr(pos1,html,".gif""")+4
		htmldata = trim(mid(html,pos1,pos2-pos1))
		GetData = htmldata
	End If
End function




Private Function GetHTML(strURL)
	Dim objXMLHTTP,data,objRS 
	Set objXMLHTTP = CreateObject("Microsoft.XMLHTTP")
	objXMLHTTP.Open "GET", strURL, False
	objXMLHTTP.Send
	data = objXMLHTTP.responseBody
	Set objXMLHTTP = Nothing
	Set objRS = CreateObject("ADODB.Recordset")
	objRS.Fields.AppEnd "txt",200,32000,&H00000080
	objRS.Open
	objRS.AddNew
	objRS.Fields("txt").AppEndChunk data
	GetHTML = objRS("txt").Value
	objRS.Close
	Set objRS = Nothing
End Function




Private Function GetPicture(strIMG, imgName, pathToIrfanView)
	Dim objXMLHTTP

	SamurizeDir = CreateObject("WScript.Shell").RegRead("HKEY_CURRENT_USER\Software\Serious Samurize\General\DirPath")
	GarDir = SamurizeDir & "Garfield\"

	Set objXMLHTTP = CreateObject("Microsoft.XMLHTTP")

	objXMLHTTP.Open "GET", strIMG, False
	objXMLHTTP.Send
	binaryData = objXMLHTTP.responseBody
	Set objXMLHTTP = Nothing
	
	Set fso = CreateObject("Scripting.FileSystemObject")
	Set MyFile = fso.CreateTextFile(imgName, True)	
	MyFile.Write SimpleBinaryToString(binaryData)
	Set MyFile = Nothing

	Set fso = Nothing
	imgName = Convert(imgName, pathToIrfanView)

	GetPicture = imgName
End Function






Private Function Convert(imgName, pathToIrfanView)
	Dim a, newFile
	
	SamurizeDir = CreateObject("WScript.Shell").RegRead("HKEY_CURRENT_USER\Software\Serious Samurize\General\DirPath")
	GarDir = SamurizeDir & "Garfield\"
	
	Set oShell = CreateObject ("WSCript.shell")
	
	Set fso = CreateObject("Scripting.FileSystemObject")
	removeExt = Int(len(imgName)-3)
	newFile = trim(Left(imgName,removeExt)) & "png"
	
	str = Chr(34) & pathToIrfanView & "\i_view32.exe" & Chr(34) & " " & imgName & " /bpp=24 /silent /convert=" & newFile
	oShell.run str ,1,false
		
	Set oShell = Nothing
	wait(10)
	Convert = newFile
End Function

Sub Wait(WaitSeconds)
	SecCount = 0
	Sec2 = 0
	While SecCount < WaitSeconds + 1
		Sec1 = Second(Time())
		If Sec1 <> Sec2 Then
			Sec2 = Second(Time())
			SecCount = SecCount + 1
		End If
	Wend 
End Sub


Private Function SimpleBinaryToString(Binary)
	'SimpleBinaryToString converts binary data (VT_UI1 | VT_ARRAY Or MultiByte string)
	'to a string (BSTR) using MultiByte VBS functions
	Dim I, S
	For I = 1 To LenB(Binary)
		S = S & Chr(AscB(MidB(Binary, I, 1)))
	Next
	SimpleBinaryToString = S
End Function